'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactClickOutside = require('react-click-outside');

var _reactClickOutside2 = _interopRequireDefault(_reactClickOutside);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _SelectableList = require('../SelectableList');

var _SelectableList2 = _interopRequireDefault(_SelectableList);

var _styles = require('./styles');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ActionMenu = function (_Component) {
    _inherits(ActionMenu, _Component);

    function ActionMenu(props) {
        _classCallCheck(this, ActionMenu);

        var _this = _possibleConstructorReturn(this, (ActionMenu.__proto__ || Object.getPrototypeOf(ActionMenu)).call(this, props));

        _this.onSelected = function (item) {
            _this.setState({ showMenuItems: false });
            _this.props.onMenuSelect(item);
        };

        _this.toggleMenuItem = function () {
            _this.setState(function (_ref) {
                var showMenuItems = _ref.showMenuItems;
                return {
                    showMenuItems: !showMenuItems
                };
            });
        };

        _this.state = {
            showMenuItems: false
        };
        return _this;
    }

    _createClass(ActionMenu, [{
        key: 'handleClickOutside',
        value: function handleClickOutside() {
            this.setState({ showMenuItems: false });
        }
    }, {
        key: 'render',
        value: function render() {
            var _this2 = this;

            var showMenuItems = this.state.showMenuItems;
            var data = this.props.data;

            var isContentDataPresent = showMenuItems && data && data.length > 0;

            if (isContentDataPresent) {
                return _react2.default.createElement(
                    _styles.ActionMenuContainer,
                    null,
                    _react2.default.createElement(
                        _styles.StyledIconWrapper,
                        null,
                        _react2.default.createElement(_styles.StyledIconOpen, {
                            className: 'fa fa-ellipsis-v',
                            onClick: function onClick() {
                                _this2.toggleMenuItem();
                            }
                        }),
                        _react2.default.createElement(_styles.BorderSeparator, null),
                        _react2.default.createElement(_styles.BorderHider, null)
                    ),
                    _react2.default.createElement(
                        _styles.ContentOnOpen,
                        null,
                        _react2.default.createElement(_SelectableList2.default, {
                            listData: data,
                            onChange: function onChange(itemId) {
                                return _this2.onSelected(itemId);
                            }
                        })
                    )
                );
            }

            return _react2.default.createElement(
                _styles.ActionMenuContainer,
                null,
                _react2.default.createElement(_styles.StyledIconClose, {
                    className: 'fa fa-ellipsis-v',
                    onClick: function onClick() {
                        _this2.toggleMenuItem();
                    }
                })
            );
        }
    }]);

    return ActionMenu;
}(_react.Component);

ActionMenu.propTypes = {
    data: _propTypes2.default.arrayOf(_propTypes2.default.shape({
        id: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]),
        label: _propTypes2.default.string
    })).isRequired,
    onMenuSelect: _propTypes2.default.func
};

ActionMenu.defaultProps = {
    onMenuSelect: function onMenuSelect() {}
};

exports.default = (0, _reactClickOutside2.default)(ActionMenu);