'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactClickOutside = require('react-click-outside');

var _reactClickOutside2 = _interopRequireDefault(_reactClickOutside);

var _styles = require('./styles');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var CustomSelect = function (_Component) {
    _inherits(CustomSelect, _Component);

    function CustomSelect(props) {
        _classCallCheck(this, CustomSelect);

        var _this = _possibleConstructorReturn(this, (CustomSelect.__proto__ || Object.getPrototypeOf(CustomSelect)).call(this, props));

        _this.toggle = function () {
            _this.setState({
                show: !_this.state.disabled && !_this.state.show
            });
            if (_this.props.onToggle) {
                _this.props.onToggle(_this.props.name);
            }
        };

        _this.state = {
            show: props.isOpen,
            disabled: props.disable
        };
        return _this;
    }

    _createClass(CustomSelect, [{
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(nextProps) {
            if (this.props.disable !== nextProps.disable) {
                this.setState({
                    disabled: nextProps.disable
                });
            }
            if (this.props.isOpen !== nextProps.isOpen) {
                this.setState({
                    show: nextProps.isOpen
                });
            }
        }
    }, {
        key: 'componentDidUpdate',
        value: function componentDidUpdate() {
            if (this.selectTextContainerRef && this.selectBodyRef) {
                var selectTextDimensions = this.selectTextContainerRef.getBoundingClientRect();

                this.selectBodyRef.style['min-width'] = selectTextDimensions.width + 'px';
                this.selectBodyRef.style['border-radius'] = '0 0 2px 2px';
            }
        }
    }, {
        key: 'handleClickOutside',
        value: function handleClickOutside() {
            if (this.state.show) {
                this.toggle.call(this);
            }
        }
    }, {
        key: 'render',
        value: function render() {
            var _this2 = this;

            if (this.state.show) {
                return _react2.default.createElement(
                    _styles.CustomSelectWrapper,
                    null,
                    _react2.default.createElement(
                        _styles.CustomSelectTextContainerOpen,
                        {
                            onClick: this.toggle,
                            innerRef: function innerRef(comp) {
                                _this2.selectTextContainerRef = comp;
                            }
                        },
                        this.props.labelContent,
                        _react2.default.createElement(_styles.CaretIconOpen, { className: 'fa fa-caret-up' }),
                        _react2.default.createElement(_styles.BorderSeparator, null),
                        _react2.default.createElement(_styles.BorderHider, null)
                    ),
                    _react2.default.createElement(
                        _styles.ContentOnOpen,
                        {
                            innerRef: function innerRef(comp) {
                                _this2.selectBodyRef = comp;
                            }
                        },
                        this.props.children
                    )
                );
            }

            return _react2.default.createElement(
                _styles.CustomSelectWrapper,
                null,
                _react2.default.createElement(
                    _styles.CustomSelectTextContainerClosed,
                    {
                        isActive: this.props.isActive,
                        onClick: this.toggle
                    },
                    this.props.labelContent,
                    _react2.default.createElement(_styles.CaretIconClosed, { className: 'fa fa-caret-down' })
                )
            );
        }
    }]);

    return CustomSelect;
}(_react.Component);

CustomSelect.propTypes = {
    children: _propTypes2.default.node.isRequired,
    name: _propTypes2.default.string,
    disable: _propTypes2.default.bool,
    isActive: _propTypes2.default.bool,
    isOpen: _propTypes2.default.bool,
    onToggle: _propTypes2.default.func,
    labelContent: _propTypes2.default.node.isRequired
};

CustomSelect.defaultProps = {
    name: '',
    disable: false,
    isActive: false,
    isOpen: false,
    onToggle: function onToggle() {}
};

exports.default = (0, _reactClickOutside2.default)(CustomSelect);