'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _HumanReadableTime = require('../HumanReadableTime');

var _HumanReadableTime2 = _interopRequireDefault(_HumanReadableTime);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ElapsedTimer = function (_Component) {
    _inherits(ElapsedTimer, _Component);

    _createClass(ElapsedTimer, null, [{
        key: 'getElapsedTime',
        value: function getElapsedTime(eventTime) {
            return new Date() - new Date(eventTime);
        }
    }]);

    function ElapsedTimer(props) {
        _classCallCheck(this, ElapsedTimer);

        var _this = _possibleConstructorReturn(this, (ElapsedTimer.__proto__ || Object.getPrototypeOf(ElapsedTimer)).call(this, props));

        _this.render = function () {
            return _react2.default.createElement(_HumanReadableTime2.default, { millisec: _this.state.elapsedTime });
        };

        _this.state = {
            elapsedTime: ElapsedTimer.getElapsedTime(props.eventTime)
        };
        return _this;
    }

    _createClass(ElapsedTimer, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
            var _this2 = this;

            this.intervalId = setInterval(function () {
                _this2.setState({
                    elapsedTime: ElapsedTimer.getElapsedTime(_this2.props.eventTime)
                });
            }, 999);
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            clearInterval(this.intervalId);
        }
    }]);

    return ElapsedTimer;
}(_react.Component);

ElapsedTimer.propTypes = {
    eventTime: _propTypes.PropTypes.oneOfType([_propTypes.PropTypes.number, _propTypes.PropTypes.instanceOf(Date)]).isRequired
};

exports.default = ElapsedTimer;