'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _isEmpty = require('lodash/isEmpty');

var _isEmpty2 = _interopRequireDefault(_isEmpty);

var _each = require('lodash/each');

var _each2 = _interopRequireDefault(_each);

var _propTypes = require('prop-types');

var _ = require('..');

var _styles = require('./styles');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var FilterComponent = function (_React$Component) {
    _inherits(FilterComponent, _React$Component);

    _createClass(FilterComponent, null, [{
        key: 'isValuePresent',
        value: function isValuePresent(value) {
            if (Array.isArray(value)) {
                return !!value.length;
            }
            if ((typeof value === 'undefined' ? 'undefined' : _typeof(value)) === 'object') {
                return !(0, _isEmpty2.default)(value);
            }
            if (typeof value === 'boolean' && value === false) {
                return true;
            }
            return !!value;
        }
    }, {
        key: 'cleanseFilterValues',
        value: function cleanseFilterValues(listingsStateAppliedFilters) {
            var cleanFilterValue = {}; // eslint-disable-line prefer-const

            (0, _each2.default)(listingsStateAppliedFilters, function (filterValue, key) {
                if (FilterComponent.isValuePresent(filterValue)) {
                    cleanFilterValue[key] = filterValue;
                }
            });

            return cleanFilterValue;
        }
    }, {
        key: 'checkIfFilterValueEmpty',
        value: function checkIfFilterValueEmpty(filters) {
            var isFilterEmpty = true;

            (0, _each2.default)(filters, function (filter) {
                isFilterEmpty = !FilterComponent.isValuePresent(filter);
            });

            return isFilterEmpty;
        }
    }]);

    function FilterComponent(props) {
        _classCallCheck(this, FilterComponent);

        var _this = _possibleConstructorReturn(this, (FilterComponent.__proto__ || Object.getPrototypeOf(FilterComponent)).call(this, props));

        _this.onFilterApply = function () {
            var cleanFilterValues = FilterComponent.cleanseFilterValues(_this.state.filterValues);

            _this.setState({
                isApplied: true,
                appliedFilterValues: _extends({}, cleanFilterValues)
            });
            if (_this.props.onFilterApply) {
                _this.props.onFilterApply(cleanFilterValues);
            }
        };

        _this.onFilterReset = function () {
            _this.setState({
                isApplied: false,
                filterValues: {},
                appliedFilterValues: {}
            });
            if (_this.props.onFilterReset) {
                _this.props.onFilterReset();
            }
        };

        _this.makeOnFilterChange = function (child) {
            return function (value) {
                _this.setState({
                    filterValues: _extends({}, _this.state.filterValues, _defineProperty({}, child.props.name, value))
                }, function () {
                    _this.setState({
                        isFilterEmpty: FilterComponent.checkIfFilterValueEmpty(_this.state.filterValues)
                    });
                });
            };
        };

        _this.state = {
            isApplied: !FilterComponent.checkIfFilterValueEmpty(props.appliedFilters),
            isFilterEmpty: FilterComponent.checkIfFilterValueEmpty(props.appliedFilters),
            filterValues: _extends({}, props.appliedFilters),
            appliedFilterValues: _extends({}, props.appliedFilters)
        };
        return _this;
    }

    _createClass(FilterComponent, [{
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(newProps) {
            var filterValues = _extends({}, newProps.appliedFilters);

            this.setState({
                isApplied: !FilterComponent.checkIfFilterValueEmpty(filterValues),
                isFilterEmpty: FilterComponent.checkIfFilterValueEmpty(filterValues),
                filterValues: filterValues,
                appliedFilterValues: _extends({}, newProps.appliedFilters)
            });
        }
    }, {
        key: 'processChildren',
        value: function processChildren() {
            var _this2 = this;

            return _react2.default.Children.map(this.props.children, function (child) {
                return _react2.default.createElement(
                    _react2.default.Fragment,
                    null,
                    _react2.default.createElement(
                        _styles.DivWrapper,
                        null,
                        _react2.default.cloneElement(child, {
                            isActive: FilterComponent.isValuePresent(_this2.state.appliedFilterValues[child.props.name]),
                            value: _this2.state.filterValues[child.props.name],
                            onChange: _this2.makeOnFilterChange(child)
                        })
                    ),
                    _react2.default.createElement(_styles.Separator, null)
                );
            });
        }
    }, {
        key: 'render',
        value: function render() {
            return _react2.default.createElement(
                _styles.FiltersContainer,
                null,
                this.processChildren(),
                _react2.default.createElement(
                    _styles.ActionsWrapper,
                    null,
                    _react2.default.createElement(
                        _styles.DivWrapper,
                        null,
                        _react2.default.createElement(
                            _.SecondaryBtn,
                            {
                                onClick: this.state.isFilterEmpty ? this.onFilterReset : this.onFilterApply,
                                disabled: this.state.isFilterEmpty && !this.state.isApplied
                            },
                            this.props.applyText
                        )
                    ),
                    _react2.default.createElement(
                        _styles.DivWrapper,
                        null,
                        this.state.isApplied && _react2.default.createElement(
                            _styles.TertiaryBtnContainer,
                            null,
                            _react2.default.createElement(
                                _.TertiaryBtn,
                                { onClick: this.onFilterReset },
                                this.props.resetText
                            )
                        )
                    )
                )
            );
        }
    }]);

    return FilterComponent;
}(_react2.default.Component);

FilterComponent.propTypes = {
    applyText: _propTypes.PropTypes.string,
    resetText: _propTypes.PropTypes.string,
    children: _propTypes.PropTypes.node.isRequired,
    onFilterApply: _propTypes.PropTypes.func,
    onFilterReset: _propTypes.PropTypes.func,
    appliedFilters: _propTypes.PropTypes.shape({})
};

FilterComponent.defaultProps = {
    applyText: 'Apply',
    resetText: 'Reset',
    appliedFilters: {},
    onFilterApply: function onFilterApply() {},
    onFilterReset: function onFilterReset() {}
};

exports.default = FilterComponent;