'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _style = require('./style');

var _ErrorInstance = require('./handler/ErrorInstance');

var _FormInstance = require('./handler/FormInstance');

var _ButtonInstance = require('./handler/ButtonInstance');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var map = _react2.default.Children.map;

/*
FormComponent parses all formElements and keeps the validation state
*/

var FormComponent = function (_React$Component) {
    _inherits(FormComponent, _React$Component);

    _createClass(FormComponent, null, [{
        key: 'errorStateSet',
        value: function errorStateSet(obj, name, previousErrState) {
            var errorState = {};
            var errorStateName = name + '_error';
            errorState = _extends({}, previousErrState);
            errorState.error = _extends({}, previousErrState.error);
            if (!obj.isValid) {
                errorState.error[errorStateName] = obj.message;
            }
            if (errorState.error && errorState.error[errorStateName] && obj.isValid) {
                delete errorState.error[errorStateName];
            }
            errorState.validationError = !!Object.keys(errorState.error).length;
            return errorState;
        }
    }]);

    function FormComponent(props) {
        _classCallCheck(this, FormComponent);

        var _this = _possibleConstructorReturn(this, (FormComponent.__proto__ || Object.getPrototypeOf(FormComponent)).call(this, props));

        _this.errorObj = {};
        _this.allNodes = {};
        _this.values = {};
        _this.state = {
            validationError: false,
            error: {}
        };
        return _this;
    }

    _createClass(FormComponent, [{
        key: 'validatationOnChange',
        value: function validatationOnChange(obj, name) {
            this.errorObj = FormComponent.errorStateSet(obj, name, this.errorObj);
            this.setState(function (previousErrState) {
                return FormComponent.errorStateSet(obj, name, previousErrState);
            });
        }
    }, {
        key: 'validate',
        value: function validate() {
            var _this2 = this;

            Object.keys(this.allNodes).forEach(function (node) {
                _this2.values[node] = _this2.allNodes[node].state.value;
                _this2.allNodes[node].validate.call(_this2.allNodes[node], _this2.allNodes[node].state.value);
            });
        }
    }, {
        key: 'parseAllNode',
        value: function parseAllNode(node) {
            var _this3 = this;

            if (node.type !== _style.ElementWrapper) {
                throw Error('Wrap the node in ElementWrapper Element');
            }
            return _react2.default.createElement(
                _style.ElementWrapper,
                node.props,
                map(node.props.children, function (elems) {
                    elems = _FormInstance.FormInstanceHandler.call(_this3, elems);
                    elems = _ErrorInstance.ErrorInstanceHandler.call(_this3, elems);
                    elems = _ButtonInstance.ButtonInstanceHandler.call(_this3, elems);
                    return elems;
                })
            );
        }
    }, {
        key: 'compute',
        value: function compute() {
            //  TODO: Memoize some of the results
            return map(this.props.children, this.parseAllNode.bind(this));
        }
    }, {
        key: 'render',
        value: function render() {
            return _react2.default.createElement(
                'form',
                null,
                this.compute()
            );
        }
    }]);

    return FormComponent;
}(_react2.default.Component);

FormComponent.propTypes = {
    children: _propTypes2.default.node.isRequired
};

exports.default = FormComponent;