'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styles = require('./styles');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var PageNavigator = function (_Component) {
    _inherits(PageNavigator, _Component);

    function PageNavigator(props) {
        _classCallCheck(this, PageNavigator);

        var _this = _possibleConstructorReturn(this, (PageNavigator.__proto__ || Object.getPrototypeOf(PageNavigator)).call(this, props));

        _this.handleKeyPress = function (e) {
            var currentPage = parseInt(e.target.innerText);

            if (e.key === 'Enter' && !Number.isNaN(currentPage)) {
                _this.props.onCurrentPageChange(currentPage);
                _this.setState({ currentPageEditable: false });

                /* Hack to simulate blur effect, as blur is not available for span */
                setTimeout(function () {
                    _this.setState({ currentPageEditable: true });
                }, 0);
                e.preventDefault();
            } else if (e.key === 'Enter') {
                e.preventDefault();
            }
        };

        _this.handleKeyUp = function (e) {
            _this.setState({ currentPage: e.target.innerText });
        };

        _this.state = {
            currentPageEditable: true,
            currentPage: _this.props.currentPage
        };
        return _this;
    }

    _createClass(PageNavigator, [{
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(nextProps) {
            if (nextProps.currentPage !== this.state.currentPage) {
                this.setState({ currentPage: nextProps.currentPage });
            }
        }
    }, {
        key: 'render',
        value: function render() {
            return _react2.default.createElement(
                _styles.PageNavigatorContainer,
                null,
                _react2.default.createElement(
                    _styles.PaginatorText,
                    null,
                    this.props.currentPage,
                    ' of ',
                    this.props.totalPages,
                    ' pages'
                ),
                _react2.default.createElement(_styles.EmptySeparator, null),
                _react2.default.createElement(_styles.StyledIcon, {
                    onClick: this.props.onPreviousPage,
                    className: 'fa fa-angle-left'
                }),
                _react2.default.createElement(
                    _styles.CurrentPageChanger,
                    {
                        contentEditable: this.state.currentPageEditable,
                        onKeyPress: this.handleKeyPress,
                        onKeyUp: this.handleKeyUp,
                        suppressContentEditableWarning: true
                    },
                    this.state.currentPage
                ),
                _react2.default.createElement(_styles.StyledIcon, {
                    onClick: this.props.onNextPage,
                    className: 'fa fa-angle-right'
                })
            );
        }
    }]);

    return PageNavigator;
}(_react.Component);

PageNavigator.propTypes = {
    currentPage: _propTypes2.default.number,
    totalPages: _propTypes2.default.number,
    onPreviousPage: _propTypes2.default.func,
    onNextPage: _propTypes2.default.func,
    onCurrentPageChange: _propTypes2.default.func
};

PageNavigator.defaultProps = {
    currentPage: 0,
    totalPages: 0,
    onPreviousPage: function onPreviousPage() {},
    onNextPage: function onNextPage() {},
    onCurrentPageChange: function onCurrentPageChange() {}
};

exports.default = PageNavigator;