'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _ = require('..');

var _styles = require('./styles');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var SliderFilter = function (_React$Component) {
    _inherits(SliderFilter, _React$Component);

    function SliderFilter(props) {
        _classCallCheck(this, SliderFilter);

        var _this = _possibleConstructorReturn(this, (SliderFilter.__proto__ || Object.getPrototypeOf(SliderFilter)).call(this, props));

        _this.onSelectableListChange = function (value) {
            _this.setState({ value: value });
        };

        _this.resetFilter = function (e) {
            _this.setState({ value: '' });
            e.stopPropagation();
        };

        _this.state = {
            value: props.value
        };
        return _this;
    }

    _createClass(SliderFilter, [{
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(nextProps) {
            if (this.props.value !== nextProps.value) {
                this.setState({
                    value: nextProps.value
                });
            }
        }
    }, {
        key: 'componentDidUpdate',
        value: function componentDidUpdate(prevProps, prevState) {
            if (this.state.value !== prevState.value) {
                if (this.props.onChange) {
                    this.props.onChange(this.state.value, this.props.name);
                }
            }
        }
    }, {
        key: 'getCustomSelectLabelTemplate',
        value: function getCustomSelectLabelTemplate() {
            var _this2 = this;

            if (this.state.value || this.state.value === false) {
                var item = this.props.listData.filter(function (datum) {
                    return datum.value === _this2.state.value;
                });

                return _react2.default.createElement(
                    _styles.ChipLabelContainer,
                    null,
                    _react2.default.createElement(
                        _.Chip,
                        { onRemoveClick: this.resetFilter },
                        item[0].label
                    )
                );
            }

            return _react2.default.createElement(
                _styles.TextLabelContainer,
                null,
                this.props.label
            );
        }
    }, {
        key: 'render',
        value: function render() {
            return _react2.default.createElement(
                _.CustomSelect,
                {
                    name: this.props.name,
                    isActive: this.props.isActive,
                    labelContent: this.getCustomSelectLabelTemplate()
                },
                _react2.default.createElement(
                    _styles.CustomSelectBodyContent,
                    null,
                    _react2.default.createElement(_.SelectableList, {
                        value: this.state.value,
                        isSelectionStored: this.props.isSelectionStored,
                        listData: this.props.listData,
                        onChange: this.onSelectableListChange,
                        disabledItems: this.props.disabledItems
                    })
                )
            );
        }
    }]);

    return SliderFilter;
}(_react2.default.Component);

SliderFilter.propTypes = {
    name: _propTypes2.default.string,
    label: _propTypes2.default.string.isRequired,
    value: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]),
    isSelectionStored: _propTypes2.default.bool,
    isActive: _propTypes2.default.bool,
    listData: _propTypes2.default.arrayOf(_propTypes2.default.shape({
        value: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]),
        label: _propTypes2.default.string
    })).isRequired,
    onChange: _propTypes2.default.func,
    disabledItems: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number])
};

SliderFilter.defaultProps = {
    name: '',
    value: '',
    isSelectionStored: false,
    isActive: false,
    disabledItems: [],
    onChange: function onChange() {}
};

exports.default = SliderFilter;