'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _VisibilityToggleHelper = require('../VisibilityToggleHelper');

var _VisibilityToggleHelper2 = _interopRequireDefault(_VisibilityToggleHelper);

var _TooltipWrapper = require('./TooltipWrapper');

var _TooltipWrapper2 = _interopRequireDefault(_TooltipWrapper);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Tooltip = function (_Component) {
    _inherits(Tooltip, _Component);

    function Tooltip() {
        _classCallCheck(this, Tooltip);

        return _possibleConstructorReturn(this, (Tooltip.__proto__ || Object.getPrototypeOf(Tooltip)).apply(this, arguments));
    }

    _createClass(Tooltip, [{
        key: 'render',
        value: function render() {
            return _react2.default.createElement(
                _VisibilityToggleHelper2.default,
                {
                    clickableElem: this.props.clickableElem,
                    position: Tooltip.positionMapper(this.props.position),
                    action: 'hover'
                },
                _react2.default.createElement(
                    _TooltipWrapper2.default,
                    { position: this.props.position },
                    this.props.children
                )
            );
        }
    }], [{
        key: 'positionMapper',
        value: function positionMapper(position) {
            var availablePosition = {
                'right-top': {
                    vertical: 'parallel-top',
                    horizontal: 'right-top'
                },
                'right-center': {
                    vertical: 'parallel-center',
                    horizontal: 'right-center'
                },
                'right-bottom': {
                    vertical: 'parallel-bottom',
                    horizontal: 'right-bottom'
                },
                'left-top': {
                    vertical: 'parallel-top',
                    horizontal: 'left-top'
                },
                'left-center': {
                    vertical: 'parallel-center',
                    horizontal: 'left-center'
                },
                'left-bottom': {
                    vertical: 'parallel-bottom',
                    horizontal: 'left-bottom'
                },
                'top-left': {
                    vertical: 'top',
                    horizontal: 'left'
                },
                'top-center': {
                    vertical: 'top',
                    horizontal: 'center'
                },
                'top-right': {
                    vertical: 'top',
                    horizontal: 'right'
                },
                'bottom-left': {
                    vertical: 'bottom',
                    horizontal: 'left'
                },
                'bottom-center': {
                    vertical: 'bottom',
                    horizontal: 'center'
                },
                'bottom-right': {
                    vertical: 'bottom',
                    horizontal: 'right'
                }
            };
            if (availablePosition[position]) {
                return availablePosition[position];
            }
            throw new Error('Position not found');
        }
    }]);

    return Tooltip;
}(_react.Component);

Tooltip.propTypes = {
    clickableElem: _propTypes2.default.node.isRequired,
    children: _propTypes2.default.node.isRequired,
    position: _propTypes2.default.arrayOf(_propTypes2.default.string)
};
Tooltip.defaultProps = {
    position: 'top-right'
};

exports.default = Tooltip;